
#include <stdio.h>
#include <assert.h>
#include <err.h>
#include <pthread.h>
#include <sys/types.h>

#define ALIGNMENT	2048
#define THREAD_COUNT 	5
#define THREAD_CYCLES	2


__thread int tls_variable  __attribute__((aligned(ALIGNMENT))) = 42;

void* thread_routine(void* ctx)
{

	assert(((uintptr_t)(&tls_variable) & (ALIGNMENT - 1)) == 0);
	assert(tls_variable == 42);

	tls_variable = 9001;

	return(NULL);
}

int main(void)
{
	pthread_t thread[THREAD_COUNT];
	int i, j;

        assert(((uintptr_t)(&tls_variable) & (ALIGNMENT - 1)) == 0);
	assert(tls_variable == 42);

	tls_variable = 1337;
	for (j = 0; j < THREAD_CYCLES; j++) {
		for (i = 0; i < THREAD_COUNT; i++) {
			if (pthread_create(thread + i, NULL, &thread_routine, NULL) != 0)
				err(1, "pthread_create");
		}

		for (i = 0; i < THREAD_COUNT; i++) {
			if (pthread_join(thread[i], NULL) != 0)
				err(1, "pthread_join");
		}

		assert(tls_variable == 1337);
	}

	printf("OK.\n");
	return(0);
}
